SAVEPOINT "{savepoint}";

WITH parent_paths AS
    (SELECT path
     FROM documents_elementpath
     WHERE element_id = '{A}'::uuid
     ORDER BY path),
     child_paths AS
    (SELECT path
     FROM documents_elementpath
     WHERE element_id = '{B}'::uuid )
SELECT EXISTS
    (SELECT 1
     FROM child_paths),
    (SELECT path
     FROM child_paths
     WHERE path <> '{{}}'::uuid[]
     LIMIT 1), EXISTS
    (SELECT 1
     FROM child_paths
     WHERE path @> ARRAY['{A}'::uuid]), EXISTS
    (SELECT 1
     FROM parent_paths
     WHERE path @> ARRAY['{B}'::uuid]),
    (SELECT COUNT(*)
     FROM parent_paths),
    (SELECT path
     FROM parent_paths
     LIMIT 1),
    (SELECT COALESCE(MAX(ordering) + 1, 0)
     FROM documents_elementpath
     WHERE path @> ARRAY['{A}'::uuid]
	AND path[array_length(path, 1)] = '{A}'::uuid ) ;

INSERT INTO documents_elementpath (id, element_id, path, ordering)
SELECT uuid_generate_v4(),
       '{B}'::uuid,
       path || '{A}'::uuid,
               1
FROM documents_elementpath
WHERE element_id = '{A}'::uuid
    AND path <> ARRAY['{first_parent}'::uuid];

UPDATE "documents_elementpath"
SET "path" = ARRAY['{first_parent}'::uuid,
                   '{A}'::uuid]::uuid[], "ordering" = 1
WHERE ("documents_elementpath"."element_id" = '{B}'::uuid
       AND "documents_elementpath"."path" = '{{}}'::uuid[]);

UPDATE "documents_elementpath"
SET "path" = array_cat(ARRAY['{first_parent}'::uuid, '{A}'::uuid], "documents_elementpath"."path")::uuid[]
WHERE "documents_elementpath"."path" && (ARRAY['{B}'::uuid])::uuid[];

INSERT INTO documents_elementpath (id, element_id, path, ordering)
SELECT uuid_generate_v4(),
       child_paths.element_id,
       new_parent_paths.path || '{A}'::uuid || child_paths.path[3:],
       child_paths.ordering
FROM documents_elementpath child_paths,
     documents_elementpath new_parent_paths
WHERE child_paths.path @> ARRAY['{first_parent}'::uuid,
                                 '{A}'::uuid,
                                 '{B}'::uuid]
    AND new_parent_paths.element_id = '{A}'::uuid
    AND new_parent_paths.path <> ARRAY['{first_parent}'::uuid];

RELEASE SAVEPOINT "{savepoint}"
